diff -NaubB ./make-3.81/plugin_support.c ./make-3.81g/plugin_support.c
--- ./make-3.81/plugin_support.c	1969-12-31 21:00:00.000000000 -0300
+++ ./make-3.81g/plugin_support.c	2007-12-12 13:46:45.000000000 -0300
@@ -0,0 +1,891 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <errno.h>
+#include <sys/types.h>
+#include <sys/ipc.h>
+#include <sys/msg.h>
+#include <dlfcn.h>
+#include <unistd.h>
+#include <string.h>
+
+#include "plugin.h"
+#include "plugin_support.h"
+
+#if PLUGIN_SUPPORT
+
+#define	VAR_NAME_LEN	20
+#define	VAR_VALUE_LEN	255
+#define MAX_MSG_LEN 255
+#define	MAX_FN_NAME_LEN	50
+
+const int CHILD_PID = 0;
+const int PROJECT_ID = 0x25;    //any integer to be passed to ftok
+const int MAX_DIGITS = 10;
+
+static int msqid = -1;
+static void *handle = 0;
+char tmp_pathname[] = "make_plugin_XXXXXX";
+static int users = 0;
+
+static struct Args
+{
+    char** arguments;
+    unsigned int argc;
+    unsigned int envc;
+    unsigned int current;
+}
+current_args;
+
+typedef void (*INIT_PLUGIN_FUNCTION_PTR) (const char *, struct Plugin_data *);
+
+typedef enum PluginIndexFunction
+{
+  CONNECT,
+  ENTER_DIR,
+  EXIT_DIR,
+  CLOSE,
+  ENTER_MAKEFILE,
+  IMPLICIT_RULE,
+  BEGIN_RULE,
+  RULE_HEADER,
+  END_RULE,
+  EXIT_MAKEFILE,
+  VAR_DEFINE,
+  VAR_LOOKUP,
+  VAR_APPEND,
+  FUNCTION_CALL,
+  ENTER_RULE,
+  EXIT_RULE,
+/*  GOAL_SEEK,*/
+  BEFORE_CMD,
+  CMD_ARG,
+  AFTER_CMD,
+  CMD_FAILURE,
+  IFDEF_EVAL,
+  IFEQ_EVAL
+} PluginIndexFunction_t;
+
+
+struct plugin_msg
+{
+  long mtype;
+  PluginIndexFunction_t func_index;
+  union
+  {
+    struct
+    {
+	int keep_alive;
+    } disconnect;
+    struct
+    {
+	unsigned char dir[MAX_MSG_LEN];
+	int level;
+    } dir_entry;
+
+    struct
+    {
+	unsigned char name[MAX_MSG_LEN];
+	int flags;
+    } enter_make;
+    
+    struct
+    {
+	unsigned char rule[MAX_MSG_LEN];
+	int has_commands;
+    } implicit_rule;
+    
+    struct
+    {
+	int has_commands;
+    } begin_rule;
+    
+    struct
+    {
+	unsigned char header[MAX_MSG_LEN];
+    } rule_header;
+
+/*
+    struct
+    {
+	unsigned char goal[MAX_MSG_LEN];
+    } goal_seek;
+*/
+    struct
+    {
+	unsigned char rule[MAX_MSG_LEN];
+    } rule_enter;
+            
+    struct
+    {
+	unsigned char varname[VAR_NAME_LEN];
+	unsigned char varvalue[VAR_VALUE_LEN];
+	int origin;
+    } var_def;
+    
+    struct
+    {
+	unsigned int argc;
+	unsigned int envc;
+    } before_cmd;
+    
+    struct
+    {
+	unsigned char arg[MAX_MSG_LEN];
+    } cmd_arg;
+    
+    struct
+    {
+	int err;
+    } cmd_failure;
+    
+    struct
+    {
+	int sig;
+	int ret;
+    } after_cmd;
+    
+    struct
+    {
+	unsigned char varname[VAR_NAME_LEN];
+	unsigned char varvalue[VAR_VALUE_LEN];
+	int origin;
+	int succeeded;
+    } var_lookup;
+    
+    struct
+    {
+	unsigned char varname[VAR_NAME_LEN];
+	unsigned char oldvalue[VAR_VALUE_LEN];
+	unsigned char append[VAR_VALUE_LEN];
+	int origin;
+    } var_append;
+    
+    struct
+    {
+	unsigned char function_name[MAX_FN_NAME_LEN];
+    } function_call;
+    
+    struct
+    {
+	unsigned char target[MAX_MSG_LEN];
+	unsigned char expanded[VAR_NAME_LEN];
+	int negated;
+	int result;
+    } ifdef_eval;
+
+    struct
+    {
+	unsigned char operand1[VAR_NAME_LEN];
+	unsigned char operand2[VAR_NAME_LEN];
+	unsigned char expanded1[VAR_VALUE_LEN];
+	unsigned char expanded2[VAR_VALUE_LEN];
+	int negated;
+	int result;
+    } ifeq_eval;
+  };
+};
+
+
+int createMessageQueue ();
+int removeMessageQueue ();
+void processMsgs (struct Plugin_data *);
+int invokeFunction (struct Plugin_data *abi, const struct plugin_msg *msg);
+int send_message (const struct plugin_msg *msg);
+int plugin_setup (const char *plugin_name, struct Plugin_data *abi);
+void plugin_tear_down ();
+
+#define	SCPY(dest, source)			\
+    {						\
+	strncpy(dest, source, sizeof(dest));	\
+	dest[sizeof(dest)-1] = 0;		\
+    }
+
+/* this function is for the top-level makefile */
+int
+launch_plugin (const char *plugin_name, const char *args)
+{
+  pid_t pid = -1;
+  struct Plugin_data abi;
+  msqid = createMessageQueue ();
+  if (msqid > 0)
+    {
+/*      printf ("launch_plugin --> Creating message queue, msg queue id: %d\n",
+              msqid);*/
+      pid = fork ();
+
+      if (pid >= 0)
+        {
+          if (pid == CHILD_PID)
+            {
+              /*printf ("launch_plugin -->Child forked\n");*/
+              if (plugin_setup (plugin_name, &abi) == 0)
+                {
+                  processMsgs (&abi);   //child process will enter a loop here
+
+                  plugin_tear_down ();
+		  _Exit(0);
+                }
+              else
+                {
+		  _Exit(1);
+                }
+		
+	      /* not reached here */
+            }
+
+        }
+      else
+        {
+          printf ("Cannot fork");
+          msqid = -1;
+        }
+
+    }
+
+  /* not reached for the child */
+  return msqid;
+}
+
+int
+plugin_setup (const char *plugin_name, struct Plugin_data *abi)
+{
+  int ret_val = -1;
+  INIT_PLUGIN_FUNCTION_PTR initialize_plugin_ptr = 0;
+  handle = dlopen (plugin_name, RTLD_LAZY);
+  if (handle)
+    {
+      /*printf ("plugin_setup --> Plugin %s opened\n", plugin_name);*/
+      initialize_plugin_ptr = dlsym (handle, "initialize_plugin");
+      if (initialize_plugin_ptr)
+        {
+          /*printf ("plugin_setup --> Initializing plugin\n");*/
+	  memset(abi, 0, sizeof(struct Plugin_data));
+          (*initialize_plugin_ptr) (0, abi);
+          ret_val = 0;
+        }
+      else
+        {
+          printf ("Symbol not found");
+          ret_val = -1;
+        }
+    }
+  else
+    {
+      printf ("Cannot open plugin");
+      ret_val = -1;
+    }
+
+
+  return ret_val;
+}
+
+void
+plugin_tear_down ()
+{
+  dlclose (handle);
+  removeMessageQueue( msqid );
+  remove(tmp_pathname);
+}
+
+int
+createMessageQueue ()
+{
+  key_t key = -1;
+  int mq;
+  int tmp_file = mkstemp (tmp_pathname);
+  
+  if (tmp_file == -1)
+    {
+      perror ("Error, mkstemp failed. Cannot create msg queue");
+      return -1;
+    }
+
+  key = ftok (tmp_pathname, PROJECT_ID);
+
+  if (key > 0)
+    {
+      mq = msgget (key, 0644 | IPC_CREAT);
+
+      if (mq < 0)
+        {
+          perror ("Cannot create msg queue");
+	  remove(tmp_pathname);
+          mq = -1;
+        }
+    }
+  else
+    {
+      perror ("Cannot generate unique id to msg queue");
+      mq = -1;
+    }
+
+  return mq;
+}
+
+
+int
+removeMessageQueue ( int mq )
+{
+  struct msqid_ds buf;
+
+  int ret =  msgctl( mq, IPC_RMID, &buf);
+ 
+  if (ret != 0 )
+  {
+   switch( ret )
+   {
+     case EACCES:
+	printf( "The calling process does not have read permission\n");
+        break;
+     case EINVAL:
+        printf(" Invalid message queue id or cmd\n");
+        break;
+     case EPERM:
+        printf("The effective user ID of the calling process does not have appropriate privileges\n");
+        break;
+     default:
+        printf("Unknown error\n");
+   }
+  }
+  
+  return ret;
+}
+
+
+void
+processMsgs (struct Plugin_data *abi)
+{
+  int exit_loop = 0;
+  int error = 0;
+  
+  users = 1;
+
+  struct plugin_msg msg;
+
+  do
+    {
+      int msgresult =
+        msgrcv (msqid, (struct plugin_msg *) &msg, sizeof (msg), 0, 0);
+
+      if (msgresult == -1)
+        {
+          perror ("Cannot receive messages");
+          error = 1;
+        }
+
+      if (!error)
+        {
+          exit_loop = invokeFunction (abi, &msg);
+        }
+
+    }
+  while (!error && !exit_loop);
+}
+
+int
+invokeFunction (struct Plugin_data *abi, const struct plugin_msg *msg)
+{
+  int exit = 0;
+  switch (msg->func_index)
+    {
+    case CONNECT:
+	users++;
+	break;
+	
+    case ENTER_DIR:
+	if (abi->enter_directory_callback != NULL)
+	    abi->enter_directory_callback (msg->dir_entry.level, msg->dir_entry.dir);
+	break;
+
+    case EXIT_DIR:
+	if (abi->exit_directory_callback != NULL)
+    	    abi->exit_directory_callback ();
+	break;
+
+    case CLOSE:
+	users--;
+	if (users == 0 && !msg->disconnect.keep_alive)
+	{
+	    if (abi->close_plugin_callback != NULL)
+		abi->close_plugin_callback ();
+	    exit = 1;
+	}
+	break;
+
+    case ENTER_MAKEFILE:
+	if (abi->begin_makefile_callback != NULL)
+	    abi->begin_makefile_callback(msg->enter_make.name, msg->enter_make.flags);
+	break;
+	
+    case IMPLICIT_RULE:
+	if (abi->parse_implicit_rule != NULL)
+	    abi->parse_implicit_rule(msg->implicit_rule.rule, msg->implicit_rule.has_commands);
+	break;
+	
+    case BEGIN_RULE:
+	if (abi->begin_parse_rule != NULL)
+	    abi->begin_parse_rule(msg->begin_rule.has_commands);
+	break;
+	
+    case RULE_HEADER:
+	if (abi->parse_rule_header != NULL)
+	    abi->parse_rule_header(msg->rule_header.header);
+	break;
+	
+    case END_RULE:
+	if (abi->end_parse_rule != NULL)
+	    abi->end_parse_rule();
+	break;
+	
+    case EXIT_MAKEFILE:
+	if (abi->end_makefile_callback != NULL)
+	    abi->end_makefile_callback();
+	break;
+/*    
+    case GOAL_SEEK:
+	if (abi->goal_seek_callback != NULL)
+	    abi->goal_seek_callback(msg->goal_seek.goal);
+	break;
+*/
+    case ENTER_RULE:
+	if (abi->rule_enter_callback != NULL)
+	    abi->rule_enter_callback(msg->rule_enter.rule);
+	break;
+	
+    case EXIT_RULE:
+	if (abi->rule_exit_callback != NULL)
+	    abi->rule_exit_callback();
+	break;
+        
+    case BEFORE_CMD:
+	if (abi->before_command_callback != NULL)
+	{
+	    /*abi->before_command_callback(msg->before_cmd.cmd);*/
+	    current_args.argc      = msg->before_cmd.argc;
+	    current_args.envc      = msg->before_cmd.envc;
+	    current_args.arguments = (char**) malloc( (current_args.argc + current_args.envc) * sizeof(char*) );
+	    current_args.current   = 0;
+	}
+	break;
+	
+    case CMD_ARG:
+	if (abi->before_command_callback != NULL)
+	{
+	    current_args.arguments[current_args.current] = strdup(msg->cmd_arg.arg);
+	    current_args.current++;
+	    
+	    /* check if it is the last one */
+	    if (current_args.current == (current_args.argc + current_args.envc))
+	    {
+		unsigned int i;
+		abi->before_command_callback((const char**) &current_args.arguments[0], current_args.argc, 
+					     (const char**) &current_args.arguments[0 + current_args.argc], current_args.envc);
+		
+		for (i=0; i < current_args.current; i++)
+		    free(current_args.arguments[i]);
+		    
+		free(current_args.arguments);
+	    }
+	}
+	break;
+    
+    case CMD_FAILURE:
+	break;
+	
+    case AFTER_CMD:
+	if (abi->after_command_callback != NULL)
+	    abi->after_command_callback(msg->after_cmd.sig, msg->after_cmd.ret);
+	break;
+    
+    case VAR_DEFINE:
+	if (abi->var_define_callback != NULL)
+	    abi->var_define_callback(msg->var_def.varname, msg->var_def.varvalue, msg->var_def.origin);
+	break;
+
+    case VAR_LOOKUP:
+	if (abi->var_lookup_callback != NULL)
+	{
+	    const char* value = (msg->var_lookup.succeeded ? msg->var_lookup.varvalue : 0);
+	    abi->var_lookup_callback(msg->var_lookup.varname, value, msg->var_lookup.origin);
+	}
+	break;
+	
+    case VAR_APPEND:
+	if (abi->var_append_callback != NULL)
+	    abi->var_append_callback(msg->var_append.varname, msg->var_append.oldvalue, msg->var_append.append, msg->var_append.origin);
+	break;
+
+    case FUNCTION_CALL:
+	if (abi->function_call_callback != NULL)
+	    abi->function_call_callback(msg->function_call.function_name);
+	break;
+        
+    case IFDEF_EVAL:
+	if (abi->ifdef_eval_callback != NULL)
+	    abi->ifdef_eval_callback(msg->ifdef_eval.target, msg->ifdef_eval.expanded, msg->ifdef_eval.negated, msg->ifdef_eval.result);
+	break;
+    
+    case IFEQ_EVAL:
+	if (abi->ifeq_eval_callback != NULL)
+	    abi->ifeq_eval_callback(msg->ifeq_eval.operand1, msg->ifeq_eval.operand2, msg->ifeq_eval.expanded1, msg->ifeq_eval.expanded2, msg->ifeq_eval.negated, msg->ifeq_eval.result);
+	break;
+    
+    default:
+      printf ("invokeFunction-->Error: invalid function index\n");
+    }
+
+  return exit;
+}
+
+int
+send_message (const struct plugin_msg *msg)
+{
+  int ret_val = -1;
+
+  if (msgsnd (msqid, msg, sizeof (struct plugin_msg), 0) == -1)
+    {
+      perror ("msgsnd");
+      ret_val = -1;
+    }
+  else
+    {
+      ret_val = 0;
+    }
+  return ret_val;
+}
+
+
+/* these functions are for the nested makefiles */
+void
+connect_to_plugin (int mq)
+{
+  msqid = mq; 
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = CONNECT;
+    send_message(&message);
+  }
+}
+
+void
+disconnect_from_plugin (int keep_alive)
+{
+  if (msqid != -1)
+  {
+    /*printf ("closing plugin\n");*/
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = CLOSE;
+    message.disconnect.keep_alive = keep_alive;
+    if (send_message (&message) != 0)
+    {
+      printf ("Error closing plugin\n");
+    }
+    msqid = -1;
+  }
+}
+
+void
+notify_entry_dir (unsigned int makelevel, const char *dir_name)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = ENTER_DIR;
+    message.dir_entry.level = makelevel;
+    SCPY(message.dir_entry.dir, dir_name);
+    send_message(&message);
+  }
+}
+
+void
+notify_exit_dir (void)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = EXIT_DIR;
+    send_message(&message);
+  }
+}
+
+void notify_entry_makefile(const char* name, int flags)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = ENTER_MAKEFILE;
+    SCPY(message.enter_make.name, name);
+    message.enter_make.flags = flags;
+    send_message(&message);
+  }
+}
+
+void notify_implicit_rule(const char* rule, int has_commands)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = IMPLICIT_RULE;
+    SCPY(message.implicit_rule.rule, rule);
+    message.implicit_rule.has_commands = has_commands;
+    send_message(&message);
+  }
+}
+
+void notify_begin_rule(int has_commands)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = BEGIN_RULE;
+    message.begin_rule.has_commands = has_commands;
+    send_message(&message);
+  }
+}
+
+void notify_rule_header(const char* header)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = RULE_HEADER;
+    SCPY(message.rule_header.header, header);
+    send_message(&message);
+  }
+}
+
+void notify_end_rule(void)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = END_RULE;
+    send_message(&message);
+  }
+}
+
+void notify_exit_makefile(void)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = EXIT_MAKEFILE;
+    send_message(&message);
+  }
+}
+
+static unsigned int count_array(char* arr[])
+{
+    unsigned int i;
+    
+    i=0;
+    while (arr[i] != NULL)
+	i++;
+	
+    return i;
+}
+
+static void send_args_array(char* arr[])
+{
+    unsigned int i;
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = CMD_ARG;
+    
+    i=0;
+    while (arr[i] != NULL)
+    {
+	SCPY(message.cmd_arg.arg, arr[i]);
+	send_message(&message);
+	i++;
+    }
+}
+
+void notify_before_command(char* argv[], char* env[])
+{
+  if (msqid != -1)
+  {
+    unsigned int i;
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = BEFORE_CMD;
+    
+    message.before_cmd.argc = count_array(argv);
+    message.before_cmd.envc = count_array(env);
+
+    send_message(&message);
+    
+    /* send args */
+    send_args_array(argv);
+    send_args_array(env);
+  }
+}
+
+void notify_command_failure(int err)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = CMD_FAILURE;
+    message.cmd_failure.err = err;
+    send_message(&message);
+  }
+}
+
+void notify_after_command(int sig, int ret)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = AFTER_CMD;
+    message.after_cmd.sig = sig;
+    message.after_cmd.ret = ret;
+    send_message(&message);
+  }
+}
+
+void notify_var_define(const char* varname, const char* value, int origin)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = VAR_DEFINE;
+    SCPY(message.var_def.varname, varname);
+    SCPY(message.var_def.varvalue, value);
+    message.var_def.origin = origin;
+    send_message(&message);
+  }
+}
+
+void notify_var_lookup(const char* varname, const char* value, int origin)  /* value == NULL means not found */
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = VAR_LOOKUP;
+    SCPY(message.var_lookup.varname, varname);
+    if (value != NULL)
+    {
+	SCPY(message.var_lookup.varvalue, value);
+	message.var_lookup.succeeded = 1;
+    }
+    else
+	message.var_lookup.succeeded = 0;
+	
+    message.var_lookup.origin = origin;
+    send_message(&message);
+  }
+}
+
+void notify_var_append(const char* varname, const char* oldvalue, const char* appending, int origin)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = VAR_APPEND;
+    SCPY(message.var_append.varname, varname);
+    SCPY(message.var_append.oldvalue, oldvalue);
+    SCPY(message.var_append.append, appending);
+    message.var_append.origin = origin;
+    send_message(&message);
+  }
+}
+
+/*
+void notify_goal_seek(const char* goal)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = GOAL_SEEK;
+    SCPY(message.goal_seek.goal, goal);
+    send_message(&message);
+  }
+}
+*/
+
+void notify_entry_rule(const char* rule) 
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = ENTER_RULE;
+    SCPY(message.rule_enter.rule, rule);
+    send_message(&message);
+  }
+}
+
+void notify_exit_rule(void)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = EXIT_RULE;
+    send_message(&message);
+  }
+}
+
+void notify_function_call(const char* function_name)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = FUNCTION_CALL;
+    SCPY(message.function_call.function_name, function_name);
+    send_message(&message);
+  }
+}
+
+void notify_ifdef_eval(const char* target, const char* exp, int negated, int result)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = IFDEF_EVAL;
+    SCPY(message.ifdef_eval.target, target);
+    SCPY(message.ifdef_eval.expanded, exp);
+    message.ifdef_eval.negated = negated;
+    message.ifdef_eval.result = result;
+    send_message(&message);
+  }
+}
+
+void notify_ifeq_eval(const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result)
+{
+  if (msqid != -1)
+  {
+    struct plugin_msg message;
+    message.mtype = 2;
+    message.func_index = IFEQ_EVAL;
+    SCPY(message.ifeq_eval.operand1, op1);
+    SCPY(message.ifeq_eval.operand2, op2);
+    SCPY(message.ifeq_eval.expanded1, exp1);
+    SCPY(message.ifeq_eval.expanded2, exp2);
+    message.ifeq_eval.negated = negated;
+    message.ifeq_eval.result = result;
+    send_message(&message);
+  }
+}
+
+#endif
diff -NaubB ./make-3.81/plugin_support.h ./make-3.81g/plugin_support.h
--- ./make-3.81/plugin_support.h	1969-12-31 21:00:00.000000000 -0300
+++ ./make-3.81g/plugin_support.h	2007-12-12 13:46:46.000000000 -0300
@@ -0,0 +1,76 @@
+#ifndef PLUGIN_SUPPORT_H
+#define PLUGIN_SUPPORT_H
+
+#if defined(_AMIGA) || defined(WINDOWS32) || defined(__EMX__) || defined(__MSDOS__)
+#  define PLUGIN_SUPPORT 0
+#else
+#  define PLUGIN_SUPPORT 1
+#endif
+
+
+#if PLUGIN_SUPPORT
+
+#define PLUGIN_OK	0
+#define	PLUGIN_ERROR	-1
+
+/* these functions are for the top-level makefile */
+int launch_plugin(const char* plugin_name, const char* args);
+/*void close_plugin(void);*/
+
+/* these functions are for the nested makefiles */
+void connect_to_plugin(int mq);
+void disconnect_from_plugin(int keep_alive);
+
+/* ============================== EVENTS ========================== */
+void notify_entry_dir(unsigned int makelevel, const char* dir_name);
+void notify_exit_dir(void);
+
+void notify_entry_makefile(const char* name, int flags);
+void notify_implicit_rule(const char* rule, int has_commands);
+void notify_begin_rule(int has_commands);
+void notify_rule_header(const char* header);
+void notify_end_rule(void);
+void notify_exit_makefile(void);
+void notify_ifdef_eval(const char* target, const char* exp, int negated, int result);
+void notify_ifeq_eval(const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result);
+
+void notify_var_define(const char* varname, const char* value, int origin);
+void notify_var_lookup(const char* varname, const char* value, int origin);  /* value == NULL means not found */
+void notify_var_append(const char* varname, const char* oldvalue, const char* appending, int origin);
+
+void notify_entry_rule(const char* rule);
+void notify_exit_rule(void);
+
+void notify_before_command(char* argv[], char* env[]);
+void notify_command_failure(int err);
+void notify_after_command(int sig, int ret);
+
+void notify_function_call(const char* function_name);
+
+#else /* no plugin support because this is not UNIX */
+
+#define connect_to_plugin(mq)
+#define disconnect_from_plugin(keep_alive)
+#define notify_entry_dir(makelevel, dir_name)
+#define notify_exit_dir()
+#define notify_entry_makefile(name, flags)
+#define notify_implicit_rule(rule, has_commands)
+#define notify_begin_rule(has_commands)
+#define notify_rule_header(header)
+#define notify_end_rule()
+#define notify_exit_makefile()
+#define notify_ifdef_eval(target, exp, negated, result)
+#define notify_ifeq_eval(op1, op2, exp1, exp2, negated, result)
+#define notify_var_define(varname, value, origin)
+#define notify_var_lookup(varname, value, origin)
+#define notify_var_append(varname, oldvalue, appending, origin)
+#define notify_entry_rule(rule)
+#define notify_exit_rule()
+#define notify_before_command(argv, env)
+#define notify_command_failure(err)
+#define notify_after_command(sig, ret)
+#define notify_function_call(function_name)
+
+#endif
+
+#endif
Common subdirectories: ./make-3.81/po and ./make-3.81g/po
diff -NaubB ./make-3.81/read.c ./make-3.81g/read.c
--- ./make-3.81/read.c	2006-03-17 11:24:20.000000000 -0300
+++ ./make-3.81g/read.c	2007-12-11 12:33:30.000000000 -0300
@@ -30,6 +30,7 @@
 #include "rule.h"
 #include "debug.h"
 #include "hash.h"
+#include "plugin_support.h"
 
 
 #ifndef WINDOWS32
@@ -307,6 +308,8 @@
   int makefile_errno;
   int r;
 
+  notify_entry_makefile(filename, flags);
+  
   ebuf.floc.filenm = strcache_add (filename);
   ebuf.floc.lineno = 1;
 
@@ -409,6 +412,7 @@
 
   free (ebuf.bufstart);
   alloca (0);
+  notify_exit_makefile();
   return r;
 }
 
@@ -1579,6 +1583,8 @@
       conditionals->ignoring[o] =
         ((v != 0 && *v->value != '\0') == (cmdtype == c_ifndef));
 
+      notify_ifdef_eval(line, var, (cmdtype == c_ifndef), !conditionals->ignoring[o]);
+      
       free (var);
     }
   else
@@ -1587,6 +1593,7 @@
       char *s1, *s2;
       unsigned int len;
       char termin = *line == '(' ? ',' : *line;
+      char *operand1, *operand2;
 
       if (termin != ',' && termin != '"' && termin != '\'')
 	return -1;
@@ -1622,6 +1629,7 @@
       else
 	*line++ = '\0';
 
+      operand1 = strdup(s1);
       s2 = variable_expand (s1);
       /* We must allocate a new copy of the expanded string because
 	 variable_expand re-uses the same buffer.  */
@@ -1671,8 +1679,13 @@
       if (*line != '\0')
 	EXTRANEOUS ();
 
+      operand2 = strdup(s2);
       s2 = variable_expand (s2);
       conditionals->ignoring[o] = (streq (s1, s2) == (cmdtype == c_ifneq));
+      
+      notify_ifeq_eval(operand1, operand2, s1, s2, (cmdtype == c_ifneq), !conditionals->ignoring[o]);
+      free(operand1);
+      free(operand2);
     }
 
  DONE:
@@ -1896,6 +1909,7 @@
   else
     cmds = 0;
 
+  notify_begin_rule(commands_idx > 0);
   for (; filenames != 0; filenames = nextf)
     {
       char *name = filenames->name;
@@ -1903,6 +1917,7 @@
       struct dep *this = 0;
       char *implicit_percent;
 
+      notify_rule_header(name);
       nextf = filenames->next;
       free (filenames);
 
@@ -2118,6 +2133,8 @@
         default_goal_file = f;
     }
 
+  notify_end_rule();    
+
   if (implicit)
     {
       targets[target_idx] = 0;
diff -NaubB ./make-3.81/remake.c ./make-3.81g/remake.c
--- ./make-3.81/remake.c	2006-03-19 23:36:37.000000000 -0300
+++ ./make-3.81g/remake.c	2007-12-11 13:06:19.000000000 -0300
@@ -23,6 +23,7 @@
 #include "dep.h"
 #include "variable.h"
 #include "debug.h"
+#include "plugin_support.h"
 
 #include <assert.h>
 
@@ -757,9 +759,15 @@
       file->ignore_vpath = 1;
     }
 
+  if (rebuilding_makefiles == 0)
+    notify_entry_rule(file->name);
+  
   /* Now, take appropriate actions to remake the file.  */
   remake_file (file);
 
+  if (rebuilding_makefiles == 0)
+    notify_exit_rule();
+
   if (file->command_state != cs_finished)
     {
       DBF (DB_VERBOSE, _("Commands of `%s' are being run.\n"));
diff -NaubB ./make-3.81/sample_plugin2.c ./make-3.81g/sample_plugin2.c
--- ./make-3.81/sample_plugin2.c	1969-12-31 21:00:00.000000000 -0300
+++ ./make-3.81g/sample_plugin2.c	2007-12-11 16:17:29.000000000 -0300
@@ -0,0 +1,236 @@
+#include <stdio.h>
+#include "plugin.h"
+
+FILE* f;
+unsigned int level = 0;
+unsigned int rule_has_commands;
+
+/* plugin implementation */
+
+static void EnterDirectory (unsigned int makelevel, const char *directory);
+static void ExitDirectory  (void);
+static void ClosePlugin    (void);
+static void VarDefine      (const char* varname, const char* value, int origin);
+static void VarLookup      (const char* varname, const char* value, int origin);
+static void VarAppend      (const char* varname, const char* oldvalue, const char* appending, int origin);
+static void FuncCall       (const char* function);
+static void EnterMakefile  (const char* name, int flags);
+static void EnterRule      (int has_commands);
+static void RuleHeader     (const char* header);
+static void ExitRule       (void);
+static void ExitMakefile   (void);
+static void GoalSeek       (const char* goal);
+static void ProcessRuleIn  (const char* rule);
+static void ProcessRuleOut (void);
+static void CmdBefore      (const char* argv[], unsigned int argc, const char* env[], unsigned int envc);
+static void CmdAfter       (int sig, int ret);
+
+static void IfDefEval      (const char* target, const char* exp, int negated, int result);
+static void IfEqEval       (const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result);
+
+
+
+static void TAB(void)
+{
+    int i;
+    for (i=0; i<level; i++)
+	fprintf(f, "\t");
+}
+
+/* Plugins shall implement the following function:
+*/
+void
+initialize_plugin (const char *argument, struct Plugin_data *data)
+{
+  data->enter_directory_callback = EnterDirectory;
+  data->exit_directory_callback = ExitDirectory;
+  data->close_plugin_callback = ClosePlugin;
+  /*
+  data->var_define_callback = VarDefine;
+  data->var_lookup_callback = VarLookup;
+  data->var_append_callback = VarAppend;
+  data->begin_makefile_callback = EnterMakefile;
+  data->begin_parse_rule = EnterRule;
+  data->parse_rule_header = RuleHeader;
+  data->end_parse_rule = ExitRule;
+  data->end_makefile_callback = ExitMakefile;
+
+  data->function_call_callback = FuncCall;
+    */
+  
+  /*data->goal_seek_callback = GoalSeek;*/
+  
+  data->rule_enter_callback = ProcessRuleIn;
+  data->rule_exit_callback = ProcessRuleOut;
+  
+  data->before_command_callback = CmdBefore;
+  data->after_command_callback = CmdAfter;
+
+  data->ifdef_eval_callback = IfDefEval;
+  data->ifeq_eval_callback = IfEqEval;
+    
+  f = fopen("plugin.log", "wt");
+}
+
+
+static void
+EnterDirectory (unsigned int makelevel, const char *directory)
+{
+  TAB();
+  fprintf (f, "Plugin: Entering dir %s, level %d\n", directory, makelevel);
+  /*level++;*/
+}
+
+static void
+ExitDirectory (void)
+{
+  /*level--;*/
+  TAB();
+  fprintf (f, "Plugin: Exiting dir\n");
+}
+
+static void
+ClosePlugin ()
+{
+  fprintf (f, "Plugin: Closing\n");
+  fclose(f);
+}
+
+static void
+VarDefine (const char* varname, const char* value, int origin)
+{
+  TAB();
+  fprintf (f, "Plugin: %s = '%s' at %d\n", varname, value, origin);
+}
+
+static void
+VarLookup (const char* varname, const char* value, int origin)
+{
+  TAB();
+  if (value != 0)
+      fprintf (f, "Plugin: var lookup: %s = '%s' at %d\n", varname, value, origin);
+  else
+      fprintf (f, "Plugin: var %s lookup FAILED\n", varname);
+}
+
+static void
+VarAppend (const char* varname, const char* oldvalue, const char* appending, int origin)
+{
+  TAB();
+  fprintf (f, "Plugin: %s += '%s' at %d (old='%s')\n", varname, appending, origin, oldvalue);
+}
+
+static void
+FuncCall (const char* function)
+{
+  TAB();
+  fprintf (f, "Plugin: call to %s\n", function);
+}
+
+static void
+EnterMakefile  (const char* name, int flags)
+{
+  TAB();
+  fprintf(f, "Plugin: enter makefile '%s' flags=%d\n", name, flags);
+  /*level++;*/
+}
+
+static void
+EnterRule (int has_commands)
+{
+    TAB();
+    rule_has_commands = has_commands;
+}
+
+static void
+RuleHeader (const char* header)
+{
+    fprintf(f, "%s ", header);
+}
+
+static void
+ExitRule (void)
+{
+    if (rule_has_commands)
+	fprintf(f, ": {}\n");
+    else
+	fprintf(f, ": {CMDS}\n");
+}
+
+static void
+ExitMakefile (void)
+{
+    TAB();
+    fprintf(f, "Plugin: exit makefile\n");
+    /*level--;*/
+}
+
+static void
+ProcessRuleIn (const char* rule)
+{
+    TAB();
+    fprintf(f, "Plugin: processing rule '%s'\n", rule);
+    level++;
+}
+
+static void
+ProcessRuleOut (void)
+{
+    level--;
+    TAB();
+    fprintf(f, "Plugin: processing rule out\n");
+}
+
+
+static void
+CmdBefore (const char* argv[], unsigned int argc, const char* env[], unsigned int envc)
+{
+    unsigned int i;
+    TAB();
+    fprintf(f, "Plugin: before execute '%s'\n", argv[0]);
+    TAB();
+    fprintf(f, "\tARGS: ");
+    for(i=1; i<argc; i++)
+	fprintf(f, "%s ", argv[i]);
+    fprintf(f, "\n");
+#if 0
+    TAB();
+    fprintf(f, "\tENV: ");
+    for(i=0; i<envc; i++)
+	fprintf(f, "%s ", env[i]);
+    fprintf(f, "\n");
+#endif
+}
+
+static void
+CmdAfter (int sig, int ret)
+{
+    TAB();
+    if (sig != 0 || ret != 0)
+	fprintf(f, "Plugin: command failed, returned %d, sig %d\n", ret, sig);
+    else
+	fprintf(f, "Plugin: after execute, returned %d\n", ret);
+}
+
+static void
+IfDefEval (const char* target, const char* exp, int negated, int result)
+{
+    TAB();
+    fprintf(f, "%s %s (='%s') returned %s\n", 
+	(negated ? "IFNDEF" : "IFDEF"),
+	target, 
+	exp, 
+	(result ? "TRUE" : "FALSE"));
+}
+
+static void
+IfEqEval (const char* op1, const char* op2, const char* exp1, const char* exp2, int negated, int result)
+{
+    TAB();
+    fprintf(f, "%s %s == %s ('%s' == '%s') returned %s\n", 
+	(negated ? "IFNEQ" : "IFEQ"),
+	op1, op2,
+	exp1, exp2,
+	(result ? "TRUE" : "FALSE"));
+}
+
Common subdirectories: ./make-3.81/tests and ./make-3.81g/tests
